module Alarmes

sig Tecnico {
	nome : Nome,
	qual : some Tipo
}

sig Alarme {
	descricao : Mensagem,
	tipo : Tipo
}

abstract sig Tipo {}

one sig Mec,Qui,Ele,Bio extends Tipo {}

sig Turno {
	equipa : set Tecnico
}

sig Nome {}

sig Mensagem {}

fact NaoHaNomesIguais {
	nome in Tecnico lone -> Nome
--	all disj x, y : Tecnico | x.nome != y.nome
}

run {}

fun horario' [t : Tecnico] : set Turno {
	{x : Turno | t in x.equipa}	
}

fun horario [t : Tecnico] : set Turno {
	equipa.t
}

check {all t : Tecnico | horario[t] = horario'[t]}

fun tecnicos [a : Alarme, t : Turno] : set Tecnico {
	{x : Tecnico | x in t.equipa && a.tipo in x.qual}
}

fun tecnicos' [a : Alarme, t : Turno] : set Tecnico {
	t.equipa & a.tipo.~qual
}

check {all a : Alarme, t : Turno | tecnicos[a,t] = tecnicos'[a,t]}

fact TiposSuficientesNosTurnos {
	all t : Turno | t.equipa.qual = Tipo
}

assert AFabricaESegura {
	all a : Alarme, t : Turno | some tecnicos[a,t]
}

check AFabricaESegura
