module Alarmes

sig Tecnico {
	nome : Nome,
	qual : some Tipo,
	turnos : some Turno
}

sig Alarme {
	descricao : Mensagem,
	tipo : Tipo,
	turno : Turno
}

abstract sig Tipo {}

one sig Mec,Qui,Ele,Bio extends Tipo {}

sig Turno {
}

sig Nome {}

sig Mensagem {}

fact NaoHaNomesIguais {
	nome in Tecnico lone -> Nome
}

run {} for 3 but 4 Tecnico

fun horario [t : Tecnico] : set Turno {
	t.turnos
}

fun tecnicos [a : Alarme] : set Tecnico {
	a.tipo.~qual & a.turno.~turnos
}

fact TiposSuficientesNosTurnos {
	all t : Turno | t.~turnos.qual = Tipo
}

assert AFabricaESegura {
	all a : Alarme | some tecnicos[a]
}

check AFabricaESegura
